#include	"stdThread.h"

//-----------------------------------------------------------------
// Function
//		dwNow  dwPast ̊Ԃ̌o߂߂
// Parameter
//		Ȃ
// Return
//		o
//-----------------------------------------------------------------
DWORD GetdwInterval(DWORD dwNow, DWORD dwPast)
{
	DWORD	dwInterval;

	if (dwNow >= dwPast)
		dwInterval = dwNow - dwPast;
	else
		dwInterval = dwNow + ((DWORD)(-1) - dwPast);
	return(dwInterval);
}

//-----------------------------------------------------------------
// Function
//		R[hϊ
//		UTF-8 -> UTF-16 -> SJIS
//		pbDestNULL̎AϊɕKvȃTCYԂ
//		pbDestNULLłȂAϊ̒̕Ԃ
// Parameter
//		BYTE	*pbSource	[in]ϊOUTF-8
//		BYTE	*pbDest		[in/out]ϊSJIS
//		int		*piSize		[in/out]pbDest̕KvTCY/̒
// Return
//		o
//-----------------------------------------------------------------
BOOL ConvUtf8toSJis(BYTE *pbSource, BYTE *pbDest, int *piSize)
{
	int		iSize, iSizeSJis;
	LPBYTE	pbBuffUtf16 = NULL, pbBuffSJis = NULL;

	*piSize = 0;
	//UTF-8 -> UTF-16
	iSize = ::MultiByteToWideChar(CP_UTF8, 0, (LPCSTR)pbSource, -1, NULL, 0);
	pbBuffUtf16 = (LPBYTE)calloc(iSize * 2, sizeof(BYTE));
	::MultiByteToWideChar(CP_UTF8, 0, (LPCSTR)pbSource, -1, (LPWSTR)pbBuffUtf16, iSize);
	//UTF-16 -> SJIS
	iSizeSJis = ::WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)pbBuffUtf16, -1, NULL, 0, NULL, NULL);
	if (pbDest == NULL)
	{
		*piSize = iSizeSJis;
		goto L_END;
	}
	pbBuffSJis = (LPBYTE)calloc(iSizeSJis, sizeof(BYTE));
	::WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)pbBuffUtf16, -1, (LPSTR)pbBuffSJis, iSizeSJis, NULL, NULL);
	*piSize = (int)strlen((char*)pbBuffSJis);
	memcpy(pbDest, pbBuffSJis, *piSize);

L_END:
	SAFE_FREE(pbBuffUtf16)
	SAFE_FREE(pbBuffSJis)
	return(TRUE);
}

//-----------------------------------------------------------------
// Function
//		R[hϊ
//		SJIS -> UTF-16 ->UTF-8
//		pbDestNULL̎AϊɕKvȃTCYԂ
//		pbDestNULLłȂAϊ̒̕Ԃ
// Parameter
//		BYTE	*pbSource	[in]ϊOSJIS
//		BYTE	*pbDest		[in/out]ϊUTF-8
//		int		*piSize		[in/out]pbDest̕KvTCY
// Return
//		o
//-----------------------------------------------------------------
BOOL ConvSJistoUtf8(LPBYTE pbSource, LPBYTE pbDest, int *piSize)
{
	int		iSize, iSizeUtf8;
	LPBYTE	pbBuffUtf16 = NULL, pbBuffUtf8 = NULL;

	*piSize = 0;
	//SJIS -> UTF-16
	iSize = ::MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbSource, -1, NULL, 0);
	pbBuffUtf16 = (LPBYTE)calloc(iSize * 2, sizeof(BYTE));
	::MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbSource, -1, (LPWSTR)pbBuffUtf16, iSize);
	//UTF-16 -> UTF-8
	iSizeUtf8 = ::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pbBuffUtf16, -1, NULL, 0, NULL, NULL);
	if (pbDest == NULL)
	{
		*piSize = iSizeUtf8;
		goto L_END;
	}
	pbBuffUtf8 = (LPBYTE)calloc(iSizeUtf8, sizeof(BYTE));
	WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pbBuffUtf16, -1, (LPSTR)pbBuffUtf8, iSizeUtf8, NULL, NULL);
	*piSize = (int)strlen((char*)pbBuffUtf8);
	memcpy(pbDest, pbBuffUtf8, *piSize);
L_END:
	SAFE_FREE(pbBuffUtf16)
	SAFE_FREE(pbBuffUtf8)
	return(TRUE);
}


//----------------------------------------------
// function
//		G[R[hƃG[bZ[W\܂
// parameter
//		LPCSTR pszTitle	[in]bZ[Wɂ^Cg
// return
//		G[R[h
//----------------------------------------------
int DispErrorMsg(LPCSTR pszTitle)
{
	LPVOID	lpMsgBuf;
	int		iErr = WSAGetLastError();

	FormatMessage(				//G[\쐬
		FORMAT_MESSAGE_ALLOCATE_BUFFER |			// eLXg̃蓖Ăv
		FORMAT_MESSAGE_FROM_SYSTEM |				// G[bZ[WWindowspӂĂ̂gp
		FORMAT_MESSAGE_IGNORE_INSERTS,				// ̈𖳎ăG[R[hɑ΂G[bZ[W쐬
		NULL,
		iErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),	// w
		(LPTSTR)&lpMsgBuf, 0, NULL);

	fprintf(stderr, "%s %d %s\n", pszTitle, WSAGetLastError(), (LPSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
	return(iErr);
}